#!/bin/sh
#

DATE=`date +"%Y.%m.%d_%H.%M.%S"`_backup.e2.tar.gz
ENIGMA2=`busybox pidof enigma2`
RCS=`busybox pidof rcS`
SFRAME=`busybox pidof showiframe`
echo "----------------------------------------"
echo "| syncing disk"
sync
if [ "$RCS" -eq 0 ]; then
	echo "| rcS not running"
else
	echo "| kill rcS"
	killall -9 rcS
fi

if [ "$ENIGMA2" -eq 0 ]; then
	echo "| enigma2 not running"
else
	echo "| kill enigma2"
	killall -9 enigma2
fi

if [ "$SFRAME" -eq 0 ]; then
	echo "| showiframe not running"
else
	echo "| kill showiframe"
	killall -9 showiframe
fi

echo "| touch firstboot"
touch /var/etc/.firstboot
echo "-----"
echo "| Waiting"
echo "-----"

if [ -e /etc/init.d/umount.sh ]; then
	echo "UMOUNT your MOUNTS - look LCD for infos"
	/etc/init.d/umount.sh
	sleep 10
else
	echo "UMOUNT ERROR - please install AUTOMOUNT v1.4"
fi

## create media execlude list

TMP=.tmp
EXECLUDLIST=.execludlist
echo "" > $TMP
echo "" > $EXECLUDLIST

ls -1 /media > $TMP
LIST=`cat $TMP`

for ROUND in $LIST; do
        echo " --exclude=/media/$ROUND/*" >> $EXECLUDLIST
        sed '/^ *$/d' -i $EXECLUDLIST

done
EXECLUDMEDIA=`cat $EXECLUDLIST | tr -d '\n' | sed 's/*/* /'`
rm $EXECLUDLIST
rm $TMP

## create mnt execlude list

TMP=.tmp
EXECLUDLIST=.execludlist
echo "" > $TMP
echo "" > $EXECLUDLIST

ls -1 /mnt > $TMP
LIST=`cat $TMP`

for ROUND in $LIST; do
        echo " --exclude=/mnt/$ROUND/*" >> $EXECLUDLIST
        sed '/^ *$/d' -i $EXECLUDLIST

done
EXECLUDMNT=`cat $EXECLUDLIST | tr -d '\n' | sed 's/*/* /'`
rm $EXECLUDLIST
rm $TMP

## create hdd execlude list

TMP=.tmp
EXECLUDLIST=.execludlist
echo "" > $TMP
echo "" > $EXECLUDLIST

ls -1 /hdd > $TMP
LIST=`cat $TMP`

for ROUND in $LIST; do
        echo  " --exclude=/hdd/$ROUND/*" >> $EXECLUDLIST
        sed '/^ *$/d' -i $EXECLUDLIST

done
EXECLUDHDD=`cat $EXECLUDLIST | tr -d '\n' | sed 's/*/* /'`
rm $EXECLUDLIST
rm $TMP

##
echo "|"
echo "| KOMPRESS      : zcf"
echo "| EXECLUD-SELF  : --exclude=`date +"%Y.%m.%d_%H.%M.%S"`_backup.e2.tar.gz"
echo "| EXECLUD-FILE  : --exclude=.execludlist --exclude=.tmp --exclude=swapfile" 
echo "| EXECLUD-SYS   : --exclude=sys/* --exclude=proc/* --exclude=tmp/* --exclude=ram/* --exclude=dev/* --exclude=dev.static/*"
echo "| EXECLUD-HDD   : $EXECLUDHDD"
echo "| EXECLUD-MNT   : $EXECLUDMNT"
echo "| EXECLUD-MEDIA : $EXECLUDMEDIA"
echo "| ADD-LIST      : --add-file=/dev/MAKEDEV /"
echo "|"
echo "| Backup started"
/usr/lib/enigma2/python/Plugins/Extensions/BackUp/tar czf /root/`date +"%Y.%m.%d_%H.%M.%S"`_backup.e2.tar.gz --exclude=`date +"%Y.%m.%d_%H.%M.%S"`_backup.e2.tar.gz --exclude=.execludlist --exclude=.tmp --exclude=swapfile --exclude=sys/* --exclude=proc/* --exclude=tmp/* --exclude=ram/* --exclude=dev/* --exclude=dev.static/* $EXECLUDHDD $EXECLUDMNT $EXECLUDMEDIA --add-file=/dev/MAKEDEV /


echo "| Backup created"
echo "-----"
echo "| remove firstboot"
rm /var/etc/.firstboot
echo "| syncing disk"
sync
echo "| your backup idled in /root/$DATE"
echo "| copy to pc with ftpclient"
echo "| restart your Box or start enigma2"
echo "-----"
echo "| Backup done"
echo "----------------------------------------"